include machine.e
include dll.e

global function allocate_sequence(sequence a)
	atom b
	b=allocate(length(a)+1)
	mem_set(b,0,length(a)+1)
	poke(b,a&0)
	return b
end function

global function allocate_int(atom a)
	atom b
	b=allocate(8)
	poke4(b,a&0)
	return b
end function

global function allocate_float(atom a)
	atom b
	b=allocate(4)
	poke(b,atom_to_float32(a))
	return b
end function

global function allocate_double(atom a)
	atom b
	b=allocate(8)
	poke(b,atom_to_float64(a))
	return b
end function


global constant
	glut32=open_dll("glut32.dll"),
--Display mode bit masks.
	GLUT_RGB=			0,
	GLUT_RGBA=			GLUT_RGB,
	GLUT_INDEX=			1,
	GLUT_SINGLE=			0,
	GLUT_DOUBLE=			2,
	GLUT_ACCUM=			4,
	GLUT_ALPHA=			8,
	GLUT_DEPTH=			16,
	GLUT_STENCIL=			32,
	GLUT_MULTISAMPLE=		128,
	GLUT_STEREO=			256,
	GLUT_LUMINANCE=			512,
--Mouse buttons.
	GLUT_LEFT_BUTTON=		0,
	GLUT_MIDDLE_BUTTON=		1,
	GLUT_RIGHT_BUTTON=		2,
--Mouse button state.
	GLUT_DOWN=			0,
	GLUT_UP=			1,
--function keys
	GLUT_KEY_F1=			1,
	GLUT_KEY_F2=			2,
	GLUT_KEY_F3=			3,
	GLUT_KEY_F4=			4,
	GLUT_KEY_F5=			5,
	GLUT_KEY_F6=			6,
	GLUT_KEY_F7=			7,
	GLUT_KEY_F8=			8,
	GLUT_KEY_F9=			9,
	GLUT_KEY_F10=			10,
	GLUT_KEY_F11=			11,
	GLUT_KEY_F12=			12,
--directional
	GLUT_KEY_LEFT=			100,
	GLUT_KEY_UP=			101,
	GLUT_KEY_RIGHT=			102,
	GLUT_KEY_DOWN=			103,
	GLUT_KEY_PAGE_UP=		104,
	GLUT_KEY_PAGE_DOWN=		105,
	GLUT_KEY_HOME=			106,
	GLUT_KEY_END=			107,
	GLUT_KEY_INSERT=		108,
--Entry/exit  state.
	GLUT_LEFT=			0,
	GLUT_ENTERED=			1,
-- Menu usage  state. 
	GLUT_MENU_NOT_IN_USE=		0,
	GLUT_MENU_IN_USE=		1,
-- Visibility  state. 
	GLUT_NOT_VISIBLE=		0,
	GLUT_VISIBLE=			1,

-- Window status  state. 
	GLUT_HIDDEN=			0,
	GLUT_FULLY_RETAINED=		1,
	GLUT_PARTIALLY_RETAINED=	2,
	GLUT_FULLY_COVERED=		3,

-- Color index component selection values. 
	GLUT_RED=			0,
	GLUT_GREEN=			1,
	GLUT_BLUE=			2,
-- Layers for use. 
	GLUT_NORMAL=			0,
	GLUT_OVERLAY=			1,


	GLUT_STROKE_ROMAN=		allocate_int(0),
	GLUT_STROKE_MONO_ROMAN=		allocate_int(1),
	GLUT_BITMAP_9_BY_15=		allocate_int(2),
	GLUT_BITMAP_8_BY_13=		allocate_int(3),
	GLUT_BITMAP_TIMES_ROMAN_10=	allocate_int(4),
	GLUT_BITMAP_TIMES_ROMAN_24=	allocate_int(5),
	GLUT_BITMAP_HELVETICA_10=	allocate_int(6),
	GLUT_BITMAP_HELVETICA_12=	allocate_int(7),
	GLUT_BITMAP_HELVETICA_18=	allocate_int(8),


GLUT_WINDOW_X=			100,
GLUT_WINDOW_Y=			101,
GLUT_WINDOW_WIDTH=		102,
GLUT_WINDOW_HEIGHT=		103,
GLUT_WINDOW_BUFFER_SIZE=	104,
GLUT_WINDOW_STENCIL_SIZE=	105,
GLUT_WINDOW_DEPTH_SIZE=		106,
GLUT_WINDOW_RED_SIZE=		107,
GLUT_WINDOW_GREEN_SIZE=		108,
GLUT_WINDOW_BLUE_SIZE=		109,
GLUT_WINDOW_ALPHA_SIZE=		110,
GLUT_WINDOW_ACCUM_RED_SIZE=	111,
GLUT_WINDOW_ACCUM_GREEN_SIZE=	112,
GLUT_WINDOW_ACCUM_BLUE_SIZE=	113,
GLUT_WINDOW_ACCUM_ALPHA_SIZE=	114,
GLUT_WINDOW_DOUBLEBUFFER=	115,
GLUT_WINDOW_RGBA=		116,
GLUT_WINDOW_PARENT=		117,
GLUT_WINDOW_NUM_CHILDREN=	118,
GLUT_WINDOW_COLORMAP_SIZE=	119,
GLUT_WINDOW_NUM_SAMPLES=	120,
GLUT_WINDOW_STEREO=		121,
GLUT_WINDOW_CURSOR=		122,
GLUT_SCREEN_WIDTH=		200,
GLUT_SCREEN_HEIGHT=		201,
GLUT_SCREEN_WIDTH_MM=		202,
GLUT_SCREEN_HEIGHT_MM=		203,
GLUT_MENU_NUM_ITEMS=		300,
GLUT_DISPLAY_MODE_POSSIBLE=	400,
GLUT_INIT_WINDOW_X=		500,
GLUT_INIT_WINDOW_Y=		501,
GLUT_INIT_WINDOW_WIDTH=		502,
GLUT_INIT_WINDOW_HEIGHT=	503,
GLUT_INIT_DISPLAY_MODE=		504,
GLUT_ELAPSED_TIME=		700,
GLUT_WINDOW_FORMAT_ID=		123,
GLUT_HAS_KEYBOARD=		600,
GLUT_HAS_MOUSE=			601,
GLUT_HAS_SPACEBALL=		602,
GLUT_HAS_DIAL_AND_BUTTON_BOX=	603,
GLUT_HAS_TABLET=		604,
GLUT_NUM_MOUSE_BUTTONS=		605,
GLUT_NUM_SPACEBALL_BUTTONS=	606,
GLUT_NUM_BUTTON_BOX_BUTTONS=	607,
GLUT_NUM_DIALS=			608,
GLUT_NUM_TABLET_BUTTONS=	609,
GLUT_DEVICE_IGNORE_KEY_REPEAT=  610,
GLUT_DEVICE_KEY_REPEAT=         611,
GLUT_HAS_JOYSTICK=		612,
GLUT_OWNS_JOYSTICK=		613,
GLUT_JOYSTICK_BUTTONS=		614,
GLUT_JOYSTICK_AXES=		615,
GLUT_JOYSTICK_POLL_RATE=	616,
GLUT_OVERLAY_POSSIBLE=          800,
GLUT_LAYER_IN_USE=		801,
GLUT_HAS_OVERLAY=		802,
GLUT_TRANSPARENT_INDEX=		803,
GLUT_NORMAL_DAMAGED=		804,
GLUT_OVERLAY_DAMAGED=		805,
GLUT_VIDEO_RESIZE_POSSIBLE=	900,
GLUT_VIDEO_RESIZE_IN_USE=	901,
GLUT_VIDEO_RESIZE_X_DELTA=	902,
GLUT_VIDEO_RESIZE_Y_DELTA=	903,
GLUT_VIDEO_RESIZE_WIDTH_DELTA=	904,
GLUT_VIDEO_RESIZE_HEIGHT_DELTA=	905,
GLUT_VIDEO_RESIZE_X=		906,
GLUT_VIDEO_RESIZE_Y=		907,
GLUT_VIDEO_RESIZE_WIDTH=	908,
GLUT_VIDEO_RESIZE_HEIGHT=	909,
GLUT_ACTIVE_SHIFT=              1,
GLUT_ACTIVE_CTRL=               2,
GLUT_ACTIVE_ALT=                4,
GLUT_CURSOR_RIGHT_ARROW=	0,
GLUT_CURSOR_LEFT_ARROW=		1,
GLUT_CURSOR_INFO=		2,
GLUT_CURSOR_DESTROY=		3,
GLUT_CURSOR_HELP=		4,
GLUT_CURSOR_CYCLE=		5,
GLUT_CURSOR_SPRAY=		6,
GLUT_CURSOR_WAIT=		7,
GLUT_CURSOR_TEXT=		8,
GLUT_CURSOR_CROSSHAIR=		9,
GLUT_CURSOR_UP_DOWN=		10,
GLUT_CURSOR_LEFT_RIGHT=		11,
GLUT_CURSOR_TOP_SIDE=		12,
GLUT_CURSOR_BOTTOM_SIDE=	13,
GLUT_CURSOR_LEFT_SIDE=		14,
GLUT_CURSOR_RIGHT_SIDE=		15,
GLUT_CURSOR_TOP_LEFT_CORNER=	16,
GLUT_CURSOR_TOP_RIGHT_CORNER=	17,
GLUT_CURSOR_BOTTOM_RIGHT_CORNER=18,
GLUT_CURSOR_BOTTOM_LEFT_CORNER= 19,
GLUT_CURSOR_INHERIT=		100,
GLUT_CURSOR_NONE=		101,
GLUT_CURSOR_FULL_CROSSHAIR=	102,
GLUT_KEY_REPEAT_OFF=		0,
GLUT_KEY_REPEAT_ON=		1,
GLUT_KEY_REPEAT_DEFAULT=	2,
GLUT_JOYSTICK_BUTTON_A=		1,
GLUT_JOYSTICK_BUTTON_B=		2,
GLUT_JOYSTICK_BUTTON_C=		4,
GLUT_JOYSTICK_BUTTON_D=		8,
GLUT_GAME_MODE_ACTIVE=          0,
GLUT_GAME_MODE_POSSIBLE=        1,
GLUT_GAME_MODE_WIDTH=           2,
GLUT_GAME_MODE_HEIGHT=          3,
GLUT_GAME_MODE_PIXEL_DEPTH=     4,
GLUT_GAME_MODE_REFRESH_RATE=    5,
GLUT_GAME_MODE_DISPLAY_CHANGED= 6,







CglutInit=define_c_proc(glut32,"glutInit",{
	C_POINTER,	--int *argcp
	C_POINTER}),	--char **argv
CglutInitDisplayMode=define_c_proc(glut32,"glutInitDisplayMode",{
	C_UINT}),	--unsigned int mode
CglutInitWindowPosition=define_c_proc(glut32,"glutInitWindowPosition",{
	C_INT,		--int x
	C_INT}),	--int y
CglutInitWindowSize=define_c_proc(glut32,"glutInitWindowSize",{
	C_INT,		--int width
	C_INT}),	--int height
CglutMainLoop=define_c_proc(glut32,"glutMainLoop",{}),
--/* GLUT window sub-API. */
CglutCreateWindow=define_c_func(glut32,"glutCreateWindow",{
	C_POINTER},	--const char *title
	C_INT),		--extern int 
CglutCreateSubWindow=define_c_func(glut32,"glutCreateSubWindow",{
	C_INT,		--int win
	C_INT,		--int x
	C_INT,		--int y
	C_INT,		--int width
	C_INT},		--int height
	C_INT),		--extern int
CglutDestroyWindow=define_c_proc(glut32,"glutDestroyWindow",{
	C_INT}),		--int win
CglutPostRedisplay=define_c_proc(glut32,"glutPostRedisplay",{}),
CglutSwapBuffers=define_c_proc(glut32,"glutSwapBuffers",{}),
CglutGetWindow=define_c_func(glut32,"glutGetWindow",{},C_INT),
CglutSetWindow=define_c_proc(glut32,"glutSetWindow",{
	C_INT}),	--(int win);
CglutSetWindowTitle=define_c_proc(glut32,"glutSetWindowTitle",{
	C_POINTER}),	--const char *title
CglutSetIconTitle=define_c_proc(glut32,"glutSetIconTitle",{
	C_POINTER}),	--const char *title
CglutPositionWindow=define_c_proc(glut32,"glutPositionWindow",{
	C_INT,		--int x
	C_INT}),	--int y
CglutReshapeWindow=define_c_proc(glut32,"glutReshapeWindow",{
	C_INT,		--int width
	C_INT}), 	--int height
CglutPopWindow=define_c_proc(glut32,"glutPopWindow",{}),
CglutPushWindow=define_c_proc(glut32,"glutPushWindow",{}),
CglutIconifyWindow=define_c_proc(glut32,"glutIconifyWindow",{}),
CglutShowWindow=define_c_proc(glut32,"glutShowWindow",{}),
CglutHideWindow=define_c_proc(glut32,"glutHideWindow",{}),
CglutFullScreen=define_c_proc(glut32,"glutFullScreen",{}),
CglutSetCursor=define_c_proc(glut32,"glutSetCursor",{
	C_INT}),	--int cursor
CglutWarpPointer=define_c_proc(glut32,"glutWarpPointer",{
	C_INT,		--int x
	C_INT}),	--int y
CglutEstablishOverlay=define_c_proc(glut32,"glutEstablishOverlay",{}),
CglutRemoveOverlay=define_c_proc(glut32,"glutRemoveOverlay",{}),
CglutUseLayer=define_c_proc(glut32,"glutUseLayer",{
	C_UINT}),	--GLenum layer
CglutPostOverlayRedisplay=define_c_proc(glut32,"glutPostOverlayRedisplay",{}),
CglutPostWindowOverlayRedisplay=define_c_proc(glut32,"glutPostWindowOverlayRedisplay",{
	C_INT}),	--int win
CglutShowOverlay=define_c_proc(glut32,"glutShowOverlay",{}),
CglutHideOverlay=define_c_proc(glut32,"glutHideOverlay",{}),
CglutCreateMenu=define_c_func(glut32,"glutCreateMenu",{
	C_POINTER},	--void (*)(int)
	C_INT),
CglutDestroyMenu=define_c_proc(glut32,"glutDestroyMenu",{
	C_INT}),	--int menu
CglutGetMenu=define_c_func(glut32,"glutGetMenu",{},C_INT),
CglutSetMenu=define_c_proc(glut32,"glutSetMenu",{
	C_INT}),	--int menu
CglutAddMenuEntry=define_c_proc(glut32,"glutAddMenuEntry",{
	C_POINTER,	--const char *label
	C_INT}),	--int value
CglutAddSubMenu=define_c_proc(glut32,"glutAddSubMenu",{
	C_POINTER,	--const char *label
	C_INT}),	--int submenu
CglutChangeToMenuEntry=define_c_proc(glut32,"glutChangeToMenuEntry",{
	C_INT,		--int item
	C_POINTER,	--const char *label
	C_INT}),	--int value
CglutChangeToSubMenu=define_c_proc(glut32,"glutChangeToSubMenu",{
	C_INT,		--int item
	C_POINTER,	--const char *label
	C_INT}),	--int submenu
CglutRemoveMenuItem=define_c_proc(glut32,"glutRemoveMenuItem",{
	C_INT}),	--int item
CglutAttachMenu=define_c_proc(glut32,"glutAttachMenu",{
	C_INT}),	--int button
CglutDetachMenu=define_c_proc(glut32,"glutDetachMenu",{
	C_INT}),	--int button
CglutDisplayFunc=define_c_proc(glut32,"glutDisplayFunc",{
	C_POINTER}),	--void (*func)(void)
CglutReshapeFunc=define_c_proc(glut32,"glutReshapeFunc",{
	C_POINTER}),	--void (*func)(int width, int height)
CglutKeyboardFunc=define_c_proc(glut32,"glutKeyboardFunc",{
	C_POINTER}),	--void (*func)(unsigned char key, int x, int y)
CglutMouseFunc=define_c_proc(glut32,"glutMouseFunc",{
	C_POINTER}),	--void (*func)(int button, int state, int x, int y)
CglutMotionFunc=define_c_proc(glut32,"glutMotionFunc",{
	C_POINTER}),	--void (*func)(int x, int y)
CglutPassiveMotionFunc=define_c_proc(glut32,"glutPassiveMotionFunc",{
	C_POINTER}),	--void (*func)(int x, int y)
CglutEntryFunc=define_c_proc(glut32,"glutEntryFunc",{
	C_POINTER}),	--void (*func)(int state)
CglutVisibilityFunc=define_c_proc(glut32,"glutVisibilityFunc",{
	C_POINTER}),	--void (*func)(int state)
CglutIdleFunc=define_c_proc(glut32,"glutIdleFunc",{
	C_POINTER}),	--void (*func)(void)
CglutTimerFunc=define_c_proc(glut32,"glutTimerFunc",{
	C_UINT,		--unsigned int millis
	C_POINTER,	--void (*func)(int value)
	C_INT}),	--int value
CglutMenuStateFunc=define_c_proc(glut32,"glutMenuStateFunc",{
	C_POINTER}),	--void (*func)(int state)
CglutSpecialFunc=define_c_proc(glut32,"glutSpecialFunc",{
	C_POINTER}),	--void (*func)(int key, int x, int y)
CglutSpaceballMotionFunc=define_c_proc(glut32,"glutSpaceballMotionFunc",{
	C_POINTER}),	--void (*func)(int x, int y, int z)
CglutSpaceballRotateFunc=define_c_proc(glut32,"glutSpaceballRotateFunc",{
	C_POINTER}),	--void (*func)(int x, int y, int z)
CglutSpaceballButtonFunc=define_c_proc(glut32,"glutSpaceballButtonFunc",{
	C_POINTER}),	--void (*func)(int button, int state)
CglutButtonBoxFunc=define_c_proc(glut32,"glutButtonBoxFunc",{
	C_POINTER}),	--void (*func)(int button, int state)
CglutDialsFunc=define_c_proc(glut32,"glutDialsFunc",{
	C_POINTER}),	--void (*func)(int dial, int value)
CglutTabletMotionFunc=define_c_proc(glut32,"glutTabletMotionFunc",{
	C_POINTER}),	--void (*func)(int x, int y)
CglutTabletButtonFunc=define_c_proc(glut32,"glutTabletButtonFunc",{
	C_POINTER}),	--void (*func)(int button, int state, int x, int y)
CglutMenuStatusFunc=define_c_proc(glut32,"glutMenuStatusFunc",{
	C_POINTER}),	--void (*func)(int status, int x, int y)
CglutOverlayDisplayFunc=define_c_proc(glut32,"glutOverlayDisplayFunc",{
	C_POINTER}),	--void (*func)(void)
CglutWindowStatusFunc=define_c_proc(glut32,"glutWindowStatusFunc",{
	C_POINTER}),	--void (*func)(int state)
CglutKeyboardUpFunc=define_c_proc(glut32,"glutKeyboardUpFunc",{
	C_POINTER}),	--void (*func)(unsigned char key, int x, int y)
CglutSpecialUpFunc=define_c_proc(glut32,"glutSpecialUpFunc",{
	C_POINTER}),	--void (*func)(int key, int x, int y)
CglutJoystickFunc=define_c_proc(glut32,"glutJoystickFunc",{
	C_POINTER,	--void (*func)(unsigned int buttonMask, int x, int y, int z)
	C_INT}),	--int pollInterval
CglutSetColor=define_c_proc(glut32,"glutSetColor",{
	C_INT,		--int
	C_POINTER,	--GLfloat red
	C_POINTER,	--GLfloat green
	C_POINTER}),	--GLfloat blue
CglutGetColor=define_c_func(glut32,"glutGetColor",{
	C_INT,		--int ndx
	C_INT},		--int component
	C_POINTER),	--GLfloat
CglutCopyColormap=define_c_proc(glut32,"glutCopyColormap",{
	C_INT}),	--int win
CglutGet=define_c_func(glut32,"glutGet",{
	C_UINT},	--GLenum type
	C_INT),		--int
CglutDeviceGet=define_c_func(glut32,"glutDeviceGet",{
	C_UINT},	--GLenum type
	C_INT),		--int
CglutExtensionSupported=define_c_func(glut32,"glutExtensionSupported",{
	C_POINTER},	--const char *name
	C_INT),		--int
CglutGetModifiers=define_c_func(glut32,"glutGetModifiers",{},C_INT),--int
CglutLayerGet=define_c_func(glut32,"glutLayerGet",{
	C_UINT},	--GLenum type
	C_INT),		--int
CglutBitmapCharacter=define_c_proc(glut32,"glutBitmapCharacter",{
	C_POINTER,	--void *font
	C_INT}),	--int character
CglutBitmapWidth=define_c_func(glut32,"glutBitmapWidth",{
	C_POINTER,	--void *font
	C_INT},		--int character
	C_INT),		--int
CglutStrokeCharacter=define_c_proc(glut32,"glutStrokeCharacter",{
	C_POINTER,	--void *font
	C_INT}),	--int character
CglutStrokeWidth=define_c_func(glut32,"glutStrokeWidth",{
	C_POINTER,	--void *font
	C_INT},		--int character
	C_INT),		--int
CglutBitmapLength=define_c_func(glut32,"glutBitmapLength",{
	C_POINTER,	--void *font
	C_POINTER},	--const unsigned char *string
	C_INT),		--int
CglutStrokeLength=define_c_func(glut32,"glutStrokeLength",{
	C_POINTER,	--void *font
	C_POINTER},	--const unsigned char *string
	C_INT),		--int

CglutWireSphere=define_c_proc(glut32,"glutWireSphere",{
	C_POINTER,	--GLdouble radius
	C_INT,		--GLint slices
	C_INT}),	--GLint stacks);
CglutSolidSphere=define_c_proc(glut32,"glutSolidSphere",{
	C_POINTER,	--GLdouble radius
	C_INT,		--GLint slices
	C_INT}),	--GLint stacks
CglutWireCone=define_c_proc(glut32,"glutWireCone",{
	C_POINTER,	--GLdouble base
	C_POINTER,	--GLdouble height
	C_INT,		--GLint slices
	C_INT}),	--GLint stacks
CglutSolidCone=define_c_proc(glut32,"glutSolidCone",{
	C_POINTER,	--GLdouble base
	C_POINTER,	--GLdouble height
	C_INT,		--GLint slices
	C_INT}),	--GLint stacks
CglutWireCube=define_c_proc(glut32,"glutWireCube",{
	C_POINTER}),	--GLdouble size
CglutSolidCube=define_c_proc(glut32,"glutSolidCube",{
	C_POINTER}),	--GLdouble size
CglutWireTorus=define_c_proc(glut32,"glutWireTorus",{
	C_POINTER,	--GLdouble innerRadius
	C_POINTER,	--GLdouble outerRadius
	C_INT,		--GLint sides
	C_INT}),	--GLint rings
CglutSolidTorus=define_c_proc(glut32,"glutSolidTorus",{
	C_POINTER,	--GLdouble innerRadius
	C_POINTER,	--GLdouble outerRadius
	C_INT,		--GLint sides
	C_INT}),	--GLint rings
CglutWireDodecahedron=define_c_proc(glut32,"glutWireDodecahedron",{}),
CglutSolidDodecahedron=define_c_proc(glut32,"glutSolidDodecahedron",{}),
CglutWireTeapot=define_c_proc(glut32,"glutWireTeapot",{
	C_POINTER}),	--GLdouble size
CglutSolidTeapot=define_c_proc(glut32,"glutSolidTeapot",{
	C_POINTER}),	--GLdouble size
CglutWireOctahedron=define_c_proc(glut32,"glutWireOctahedron",{}),
CglutSolidOctahedron=define_c_proc(glut32,"glutSolidOctahedron",{}),
CglutWireTetrahedron=define_c_proc(glut32,"glutWireTetrahedron",{}),
CglutSolidTetrahedron=define_c_proc(glut32,"glutSolidTetrahedron",{}),
CglutWireIcosahedron=define_c_proc(glut32,"glutWireIcosahedron",{}),
CglutSolidIcosahedron=define_c_proc(glut32,"glutSolidIcosahedron",{}),

CglutVideoResizeGet=define_c_func(glut32,"glutVideoResizeGet",{
	C_UINT},	--GLenum param
	C_INT),		--int
CglutSetupVideoResizing=define_c_proc(glut32,"glutSetupVideoResizing",{}),
CglutStopVideoResizing=define_c_proc(glut32,"glutStopVideoResizing",{}),
CglutVideoResize=define_c_proc(glut32,"glutVideoResize",{
	C_INT,		--int x
	C_INT,		--int y
	C_INT,		--int width
	C_INT}),	--int height
CglutVideoPan=define_c_proc(glut32,"glutVideoPan",{
	C_INT,		--int x
	C_INT,		--int y
	C_INT,		--int width
	C_INT}),	--int height
CglutReportErrors=define_c_proc(glut32,"glutReportErrors",{}),
CglutIgnoreKeyRepeat=define_c_proc(glut32,"glutIgnoreKeyRepeat",{
	C_INT}),	--int ignore
CglutSetKeyRepeat=define_c_proc(glut32,"glutSetKeyRepeat",{
	C_INT}),	--int repeatMode
CglutForceJoystickFunc=define_c_proc(glut32,"glutForceJoystickFunc",{}),
CglutGameModeString=define_c_proc(glut32,"glutGameModeString",{
	C_POINTER}),	--const char *string
CglutEnterGameMode=define_c_func(glut32,"glutEnterGameMode",{},C_INT),
CglutLeaveGameMode=define_c_proc(glut32,"glutLeaveGameMode",{}),
CglutGameModeGet=define_c_func(glut32,"glutGameModeGet",{
	C_UINT},	--GLenum mode
	C_INT)		--int

include misc.e

global procedure glutInit()
	sequence cmd
	atom a,b
	cmd=command_line()
	a=allocate_int(1)
	b=allocate_int(allocate_sequence(cmd[1]))
	c_proc(CglutInit,{a,b})
	free(a)
	free(b)
end procedure

global procedure glutInitDisplayMode(integer mode)
	c_proc(CglutInitDisplayMode,{mode})
end procedure

global procedure glutInitWindowPosition(integer x,integer y)
	c_proc(CglutInitWindowPosition,{x,y})
end procedure

global procedure glutInitWindowSize(integer width, integer height)
	c_proc(CglutInitWindowSize,{width,height})
end procedure

global procedure glutMainLoop()
	c_proc(CglutMainLoop,{})
end procedure

global function glutCreateWindow(sequence title)
	atom a,b
	a=allocate_sequence(title)
	b=c_func(CglutCreateWindow,{a})
	free(a)
	return b
end function

global function glutCreateSubWindow(integer win,integer x, integer y, integer width,integer height)
	return c_func(CglutCreateSubWindow,{win,x,y,width,height})
end function

global procedure glutDestroyWindow(integer win)
	c_proc(CglutDestroyWindow,{win})
end procedure

global procedure glutPostRedisplay()
	c_proc(CglutPostRedisplay,{})
end procedure

global procedure glutSwapBuffers()
	c_proc(CglutSwapBuffers,{})
end procedure

global function glutGetWindow()
	return c_func(CglutGetWindow,{})
end function

global procedure glutSetWindow(integer win)
	c_proc(CglutSetWindow,{win})
end procedure

global procedure glutSetWindowTitle(sequence title)
	atom a
	a=allocate_sequence(title)
	c_proc(CglutSetWindowTitle,{a})
	free(a)
end procedure

global procedure glutSetIconTitle(sequence title)
	atom a
	a=allocate_sequence(title)
	c_proc(CglutSetIconTitle,{a})
	free(a)
end procedure

global procedure glutPositionWindow(integer x, integer y)
	c_proc(CglutPositionWindow,{x,y})
end procedure

global procedure glutReshapeWindow(integer width, integer height)
	c_proc(CglutReshapeWindow,{width,height})
end procedure

global procedure glutPopWindow()
	c_proc(CglutPopWindow,{})
end procedure

global procedure glutPushWindow()
	c_proc(CglutPushWindow,{})
end procedure

global procedure glutIconifyWindow()
	c_proc(CglutIconifyWindow,{})
end procedure

global procedure glutShowWindow()
	c_proc(CglutShowWindow,{})
end procedure

global procedure glutHideWindow()
	c_proc(CglutHideWindow,{})
end procedure

global procedure glutFullScreen()
	c_proc(CglutFullScreen,{})
end procedure


global procedure glutSetCursor(integer cursor)
	c_proc(CglutSetCursor,{cursor})
end procedure

global procedure glutWarpPointer(integer x, integer y)
	c_proc(CglutWarpPointer,{x,y})
end procedure

global procedure glutEstablishOverlay()
	c_proc(CglutEstablishOverlay,{})
end procedure

global procedure glutRemoveOverlay()
	c_proc(CglutRemoveOverlay,{})
end procedure

global procedure glutUseLayer(atom layer)
	c_proc(CglutUseLayer,{layer})
end procedure

global procedure glutPostOverlayRedisplay()
	c_proc(CglutPostOverlayRedisplay,{})
end procedure

global procedure glutPostWindowOverlayRedisplay(integer win)
	c_proc(CglutPostWindowOverlayRedisplay,{win})
end procedure

global procedure glutShowOverlay()
	c_proc(CglutShowOverlay,{})
end procedure

global procedure glutHideOverlay()
	c_proc(CglutHideOverlay,{})
end procedure

global function glutCreateMenu(atom callback_proc)
	return c_func(CglutCreateMenu,{callback_proc})
	--void (*)(int)
end function

global procedure glutDestroyMenu(integer menu)
	c_proc(CglutDestroyMenu,{menu})
end procedure

global function glutGetMenu()
	return c_func(CglutGetMenu,{})
end function

global procedure glutSetMenu(integer menu)
	c_proc(CglutSetMenu,{menu})
end procedure

global procedure glutAddMenuEntry(sequence label,integer value)
	atom a
	a=allocate_sequence(label)
	c_proc(CglutAddMenuEntry,{a,value})
	free(a)
end procedure

global procedure glutAddSubMenu(sequence label,integer submenu)
	atom a
	a=allocate_sequence(label)
	c_proc(CglutAddSubMenu,{a,submenu})
	free(a)
end procedure

global procedure glutChangeToMenuEntry(integer item,sequence label,integer value)
	atom a
	a=allocate(label)
	c_proc(CglutChangeToMenuEntry,{item,a,value})
	free(a)
end procedure

global procedure glutChangeToSubMenu(integer item,sequence label,integer submenu)
	atom a
	a=allocate_sequence(label)
	c_proc(CglutChangeToSubMenu,{item,a,submenu})
	free(a)
end procedure

global procedure glutRemoveMenuItem(integer item)
	c_proc(CglutRemoveMenuItem,{item})
end procedure

global procedure glutAttachMenu(integer button)
	c_proc(CglutAttachMenu,{button})
end procedure

global procedure glutDetachMenu(integer button)
	c_proc(CglutDetachMenu,{button})
end procedure

global procedure glutDisplayFunc(atom callback_func)
	c_proc(CglutDisplayFunc,{callback_func})
	--void (*func)(void)
end procedure

global procedure glutReshapeFunc(atom callback_func)
	c_proc(CglutReshapeFunc,{callback_func})
	--void (*func)(int width, int height)
end procedure

global procedure glutKeyboardFunc(atom callback_func)
	c_proc(CglutKeyboardFunc,{callback_func})
	--void (*func)(unsigned char key, int x, int y)
end procedure

global procedure glutMouseFunc(atom callback_func)
	c_proc(CglutMouseFunc,{callback_func})
	--void (*func)(int button, int state, int x, int y)
end procedure

global procedure glutMotionFunc(atom callback_func)
	c_proc(CglutMotionFunc,{callback_func})
	--void (*func)(int x, int y)
end procedure

global procedure glutPassiveMotionFunc(atom callback_func)
	c_proc(CglutPassiveMotionFunc,{callback_func})
	--void (*func)(int x, int y)
end procedure

global procedure glutEntryFunc(atom callback_func)
	c_proc(CglutEntryFunc,{callback_func})
	--void (*func)(int state)
end procedure

global procedure glutVisibilityFunc(atom callback_func)
	c_proc(CglutVisibilityFunc,{callback_func})
	--void (*func)(int state)
end procedure

global procedure glutIdleFunc(atom callback_func)
	c_proc(CglutIdleFunc,{callback_func})
	--void (*func)(void)
end procedure

global procedure glutTimerFunc(atom millis,atom callback_func,integer value)
	c_proc(CglutTimerFunc,{millis,callback_func,value})
	--void (*func)(int value)
end procedure

global procedure glutMenuStateFunc(atom callback_func)
	c_proc(CglutMenuStateFunc,{callback_func})
	--void (*func)(int state)
end procedure

global procedure glutSpecialFunc(atom callback_func)
	c_proc(CglutSpecialFunc,{callback_func})
	--void (*func)(int key, int x, int y)
end procedure

global procedure glutSpaceballMotionFunc(atom callback_func)
	c_proc(CglutSpaceballMotionFunc,{callback_func})
	--void (*func)(int x, int y, int z)
end procedure

global procedure glutSpaceballRotateFunc(atom callback_func)
	c_proc(CglutSpaceballRotateFunc,{callback_func})
	--void (*func)(int x, int y, int z)
end procedure

global procedure glutSpaceballButtonFunc(atom callback_func)
	c_proc(CglutSpaceballButtonFunc,{callback_func})
	--void (*func)(int button, int state)
end procedure

global procedure glutButtonBoxFunc(atom callback_func)
	c_proc(CglutButtonBoxFunc,{callback_func})
	--void (*func)(int button, int state)
end procedure

global procedure glutDialsFunc(atom callback_func)
	c_proc(CglutDialsFunc,{callback_func})
	--void (*func)(int dial, int value)
end procedure

global procedure glutTabletMotionFunc(atom callback_func)
	c_proc(CglutTabletMotionFunc,{callback_func})
	--void (*func)(int x, int y)
end procedure

global procedure glutTabletButtonFunc(atom callback_func)
	c_proc(CglutTabletButtonFunc,{callback_func})
	--void (*func)(int button, int state, int x, int y)
end procedure

global procedure glutMenuStatusFunc(atom callback_func)
	c_proc(CglutMenuStatusFunc,{callback_func})
	--void (*func)(int status, int x, int y)
end procedure

global procedure glutOverlayDisplayFunc(atom callback_func)
	c_proc(CglutOverlayDisplayFunc,{callback_func})
	--void (*func)(void)
end procedure

global procedure glutWindowStatusFunc(atom callback_func)
	c_proc(CglutWindowStatusFunc,{callback_func})
	--void (*func)(int state)
end procedure

global procedure glutKeyboardUpFunc(atom callback_func)
	c_proc(CglutKeyboardUpFunc,{callback_func})
	--void (*func)(unsigned char key, int x, int y)
end procedure

global procedure glutSpecialUpFunc(atom callback_func)
	c_proc(CglutSpecialUpFunc,{callback_func})
	--void (*func)(int key, int x, int y)
end procedure

global procedure glutJoystickFunc(atom callback_func,integer pollInterval)
	c_proc(CglutJoystickFunc,{callback_func,pollInterval})
	--void (*func)(unsigned int buttonMask, int x, int y, int z)
end procedure

global procedure glutSetColor(integer a,atom red,atom green,atom blue)
	atom b,c,d
	b=allocate_float(red)
	c=allocate_float(green)
	d=allocate_float(blue)
	c_proc(CglutSetColor,{a,b,c,d})
	free(b)--GLfloat red
	free(c)--GLfloat green
	free(d)--GLfloat blue
end procedure

global function glutGetColor(integer ndx,integer component)
	return float32_to_atom(peek({c_func(CglutGetColor,{ndx,component}),4}))
end function

global procedure glutCopyColormap(integer win)
	c_proc(CglutCopyColormap,{win})
end procedure

global function glutGet(atom Type)
	return c_func(CglutGet,{Type})
end function

global function glutDeviceGet(atom Type)
	return c_func(CglutDeviceGet,{Type})
end function

global function glutExtensionSupported(sequence name)
	atom a,b
	a=allocate_sequence(name)
	b=c_func(CglutExtensionSupported,{a})
	free(a)
	return b
end function

global function glutGetModifiers()
	return c_func(CglutGetModifiers,{})
end function

global function glutLayerGet(atom Type)
	return c_func(CglutLayerGet,{Type})
end function

global procedure glutBitmapCharacter(atom font,integer character)
	c_proc(CglutBitmapCharacter,{font, character})
	--void *font
end procedure

global function glutBitmapWidth(atom font,integer character)
	return c_func(CglutBitmapWidth,{font,character})
	--void *font
end function

global procedure glutStrokeCharacter(atom font,integer character)
	c_proc(CglutStrokeCharacter,{font,character})
	--void *font
end procedure

global function glutStrokeWidth(atom font,integer character)
	return c_func(CglutStrokeWidth,{font, character})
	--void *font
end function

global function glutBitmapLength(atom font,sequence string)
	atom a,b
	a=allocate_sequence(string)
	b=c_func(CglutBitmapLength,{font,a})
	--void *font
	free(a)
	return b
end function

global function glutStrokeLength(atom font,sequence string)
	atom a,b
	a=allocate_sequence(string)
	b=c_func(CglutStrokeLength,{font,a})
	free(a)
	--void *font
	return b
end function

global procedure glutWireSphere(atom radius,integer slices,integer stacks)
	atom a
	a=allocate_double(radius)
	c_proc(CglutWireSphere,{a,slices,stacks})
	free(a)
end procedure

global procedure glutSolidSphere(atom radius,integer slices,integer stacks)
	atom a
	a=allocate_double(radius)
	c_proc(CglutSolidSphere,{a,slices,stacks})
	free(a)
end procedure

global procedure glutWireCone(atom base,atom height,integer slices,integer stacks)
	atom a,b
	a=allocate_double(base)
	b=allocate_double(height)
	c_proc(CglutWireCone,{a,b,slices,stacks})
	free(a)
	free(b)
end procedure

global procedure glutSolidCone(atom base,atom height,integer slices,integer stacks)
	atom a,b
	a=allocate_double(base)
	b=allocate_double(height)
	c_proc(CglutSolidCone,{a,b,slices,stacks})
	free(a)
	free(b)
end procedure

global procedure glutWireCube(atom size)
	atom a
	a=allocate_double(a)
	c_proc(CglutWireCube,{a})
	free(a)
end procedure

global procedure glutSolidCube(atom size)
	atom a
	a=allocate_double(size)
	c_proc(CglutSolidCube,{a})
end procedure

global procedure glutWireTorus(atom innerRadius,atom outerRadius,integer sides,integer rings)
	atom a,b
	a=allocate_double(innerRadius)
	b=allocate_double(outerRadius)
	c_proc(CglutWireTorus,{a,b,sides,rings})
	free(a)
	free(b)
end procedure

global procedure glutSolidTorus(atom innerRadius,atom outerRadius,integer sides,integer rings)
	atom a,b
	a=allocate_double(innerRadius)
	b=allocate_double(outerRadius)
	c_proc(CglutSolidTorus,{a,b,sides,rings})
	free(a)
	free(b)
end procedure

global procedure glutWireDodecahedron()
	c_proc(CglutWireDodecahedron,{})
end procedure

global procedure glutSolidDodecahedron()
	c_proc(CglutSolidDodecahedron,{})
end procedure

global procedure glutWireTeapot(atom size)
	atom a
	a=allocate_double(size)
	c_proc(CglutWireTeapot,{a})
	free(a)
end procedure

global procedure glutSolidTeapot(atom size)
	atom a
	a=allocate_double(size)
	c_proc(CglutSolidTeapot,{a})
	free(a)
end procedure

global procedure glutWireOctahedron()
	c_proc(CglutWireOctahedron,{})
end procedure

global procedure glutSolidOctahedron()
	c_proc(CglutSolidOctahedron,{})
end procedure

global procedure glutWireTetrahedron()
	c_proc(CglutWireTetrahedron,{})
end procedure

global procedure glutSolidTetrahedron()
	c_proc(CglutSolidTetrahedron,{})
end procedure

global procedure glutWireIcosahedron()
	c_proc(CglutWireIcosahedron,{})
end procedure

global procedure glutSolidIcosahedron()
	c_proc(CglutSolidIcosahedron,{})
end procedure


global function glutVideoResizeGet(atom param)
	return c_func(CglutVideoResizeGet,{param})
end function

global procedure glutSetupVideoResizing()
	c_proc(CglutSetupVideoResizing,{})
end procedure

global procedure glutStopVideoResizing()
	c_proc(CglutStopVideoResizing,{})
end procedure

global procedure glutVideoResize(integer x,integer y,integer width,integer height)
	c_proc(CglutVideoResize,{x,y,width,height})
end procedure

global procedure glutVideoPan(integer x,integer y,integer width,integer height)
	c_proc(CglutVideoPan,{x,y,width,height})
end procedure

global procedure glutReportErrors()
	c_proc(CglutReportErrors,{})
end procedure

global procedure glutIgnoreKeyRepeat(integer ignore)
	c_proc(CglutIgnoreKeyRepeat,{ignore})
end procedure

global procedure glutSetKeyRepeat(integer repeatMode)
	c_proc(CglutSetKeyRepeat,{repeatMode})
end procedure

global procedure glutForceJoystickFunc()
	c_proc(CglutForceJoystickFunc,{})
end procedure

global procedure glutGameModeString(sequence string)
	atom a
	a=allocate_sequence(string)
	c_proc(CglutGameModeString,{a})
	free(a)
end procedure

global function glutEnterGameMode()
	return c_func(CglutEnterGameMode,{})
end function

global procedure glutLeaveGameMode()
	c_proc(CglutLeaveGameMode,{})
end procedure

global function glutGameModeGet(atom mode)
	return c_func(CglutGameModeGet,{mode})
end function

